
/* example4 : Show off some post processing to perform an implicit
 * plot of a 2d function.
 */


// examples4.cpp materials.h geometry.h
//
// CTriage constructor: iRenderFlags not reset.


#include <stdio.h>
#include "triage.h"

#include "render.h"
#include "inliners.h"
#include "pixels.h"
#include "targagrabber.h"
#include "matrix.h"
#include "processing.h"
#include "geometry.h"
#include "materials.h"

#include "hershey.h"
#include "line2d.h"


#define WIDTH  400
#define HEIGHT 400

CTexture2d texture(WIDTH,HEIGHT);
CTexture2d depth(WIDTH,HEIGHT);
CTriage    triage(texture,depth);
    CTriageGraphics gr(triage);




Rectangle r;
int x=10;
int y=80;
char ddd[6][17];

void dud(char*s,CHersheyFont& font)
{
    Clear(texture, Pixel(255,255,255,0));
    Clear(depth, 1000);
    CHersheyFont font2(meteorology);
    font2.drawString (s,10,40,gr);
}

void ww(int n,CHersheyFont& font)
{
    font.drawString (ddd[n],x,y,gr);
    font.stringLimit (r, ddd[n], x, y, gr);
    y+=r.height;
}
void dt(CHersheyFont& font)
{
    y=80;
    ww(0,font);
    ww(1,font);
    ww(2,font);
    ww(3,font);
    ww(4,font);
    ww(5,font);

    /*
     triage.DrawLine2d(100,100,200,300);
    triage.DrawLine2d(200,100,100,300);

    triage.DrawLine2d(150+200,300,150+100,100);
    triage.DrawLine2d(150+100,300,150+200,100);
     */
    SaveAsTarga("example5.tga",&texture[0],
                texture.Width(), texture.Height());

    system("xv example5.tga");
}

void doit(char* def, char* name)
{
    CHersheyFont font(def);
    dud(name,font);
    dt(font);
}


int main(void)
{
    //cyrilc_1
    //greekc
    //greeks
    //markers
    {
        int i,j;
        for (j=0;j<6;j++)
        {
            for (i=0;i<16;i++)
                ddd[j][i] = j*16+i+32;
            ddd[j][16]='\0';
        }
    }
    doit(gothiceng,"gothiceng");
    {
        CHersheyFont font(astrology);
        dud("fonts/astrology.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(cursive);
        dud("fonts/cursive.jhf",font);
        dt(font);
    }
    //return;
    {
        CHersheyFont font(cyrilc_1);
        dud("fonts/cyrilc1.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(cyrillic);
        dud("fonts/cyrillic.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(futural);
        dud("fonts/futural.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(futuram);
        dud("fonts/futuram.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(gothgbt);
        dud("fonts/gothgbt.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(gothgrt);
        dud("fonts/gothgrt.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(gothiceng);
        dud("fonts/gothiceng.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(gothicger);
        dud("fonts/gothicger.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(gothicita);
        dud("fonts/gothicita.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(gothitt);
        dud("fonts/gothitt.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(greek);
        dud("fonts/greek.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(greekc);
        dud("fonts/greekc.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(greeks);
        dud("fonts/greeks.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(japanese);
        dud("fonts/japanese.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(markers);
        dud("fonts/markers.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(mathlow);
        dud("fonts/mathlow.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(mathupp);
        dud("fonts/mathupp.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(meteorology);
        dud("fonts/meteorology.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(music);
        dud("fonts/music.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(romand);
        dud("fonts/romand.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(romans);
        dud("fonts/romans.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(romant);
        dud("fonts/romant.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(scriptc);
        dud("fonts/scriptc.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(scripts);
        dud("fonts/scripts.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(symbolic);
        dud("fonts/symbolic.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(timesg);
        dud("fonts/timesg.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(timesi);
        dud("fonts/timesi.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(timesib);
        dud("fonts/timesib.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(timesr);
        dud("fonts/timesr.jhf",font);
        dt(font);
    }
    {
        CHersheyFont font(timesrb);
        dud("fonts/timesrb.jhf",font);
        dt(font);
    }
    return 0;
}

